package com.firstbest.rules;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;

import junit.framework.TestCase;

import org.drools.RuleBase;
import org.drools.RuleBaseFactory;
import org.drools.WorkingMemory;
import org.drools.compiler.PackageBuilder;
import org.drools.rule.Package;

public class DroolsDefectTest extends TestCase {
	
	static {
		System.setProperty("drools.compiler", "JANINO");
	}
	
	public void test_drools() throws Exception {
		InputStream is = getClass().getClassLoader().getResourceAsStream("com/firstbest/rules/DroolsDefectTest.drl");
		Reader source = new InputStreamReader(is);
		PackageBuilder builder = new PackageBuilder();
		builder.addPackageFromDrl( source );
		Package pkg = builder.getPackage();
		RuleBase ruleBase = RuleBaseFactory.newRuleBase();
		ruleBase.addPackage( pkg );
        
        WorkingMemory workingMemory = ruleBase.newStatefulSession();     
        workingMemory.insert(new Field("t", "Y"));
        workingMemory.insert(new Field("a", "b"));
        workingMemory.insert(new Field("b", "15"));
        workingMemory.insert(new Field("c", "d"));
        workingMemory.insert(new Field("d", "15"));
        workingMemory.fireAllRules();   
 	}
	
}
